ADAM_2.12: Core 1.0.1 API < Back
 

# Packages

-  package root
  Definition Classes
    root
-  package org
  Definition Classes
    root
-  package bdgenomics
  Definition Classes
    org
-  package adam
  Definition Classes
    bdgenomics
-  package ds
  Definition Classes
    adam
-  package feature
  Definition Classes
    ds
-  package fragment
  Definition Classes
    ds
-  package read
  Definition Classes
    ds
-  package sequence
  Definition Classes
    ds
-  package variant
  Definition Classes
    ds
- ADAMContext
- ADAMSaveAnyArgs
- AvroGenomicDataset
- AvroReadGroupGenomicDataset
- DatasetBoundGenericGenomicDataset
- DatasetBoundGenomicDataset
- FullOuterShuffleRegionJoin
- GenericConverter
- GenericGenomicDataset
- GenomeBins
- GenomicBroadcast
- GenomicDataset
- GenomicDatasetConversion
- GenomicDatasetWithLineage
- GenomicPositionPartitioner
- GenomicRegionPartitioner
- InFormatter
- InFormatterCompanion
- InnerShuffleRegionJoin
- InnerShuffleRegionJoinAndGroupByLeft
- InnerTreeRegionJoin
- InnerTreeRegionJoinAndGroupByRight
- LeftOuterShuffleRegionJoin
- LeftOuterShuffleRegionJoinAndGroupByLeft
- MultisampleAvroGenomicDataset
- MultisampleGenomicDataset
- OutFormatter
- RDDBoundGenericGenomicDataset
- ReferencePartitioner
- RegionJoin
- RightOuterShuffleRegionJoinAndGroupByLeft
- RightOuterTreeRegionJoin
- RightOuterTreeRegionJoinAndGroupByRight
- ShuffleRegionJoin
- SortedIntervalPartitionJoinWithVictims
- TreeRegionJoin
- VictimlessSortedIntervalPartitionJoin

t

org.bdgenomics.adam.ds

# DatasetBoundGenomicDataset 

###

#### trait DatasetBoundGenomicDataset[T, U <: Product, V <: GenomicDataset[T, U, V]] extends GenomicDataset[T, U, V]

A trait describing a GenomicDataset that is physically backed by a Dataset.

Linear Supertypes
GenomicDataset[T, U, V], Logging, AnyRef, Any
Known Subclasses
DatasetBoundCoverageDataset, DatasetBoundFeatureDataset, DatasetBoundFragmentDataset, DatasetBoundAlignmentDataset, DatasetBoundReadDataset, DatasetBoundSequenceDataset, DatasetBoundSliceDataset, DatasetBoundGenotypeDataset, DatasetBoundVariantContextDataset, DatasetBoundVariantDataset
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. DatasetBoundGenomicDataset
2. GenomicDataset
3. Logging
4. AnyRef
5. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Abstract Value Members

1.  abstract def buildTree(rdd: RDD[(ReferenceRegion, T)])(implicit tTag: ClassTag[T]): IntervalArray[ReferenceRegion, T]
   Attributes
     protected
   Definition Classes
     GenomicDataset
2.  abstract val dataset: Dataset[U]

   These data as a Spark SQL Dataset.

   These data as a Spark SQL Dataset.

   Definition Classes
     GenomicDataset
3.  abstract def getReferenceRegions(elem: T): Seq[ReferenceRegion]
   Attributes
     protected
   Definition Classes
     GenomicDataset
4.  abstract val isPartitioned: Boolean
5.  abstract val optLookbackPartitions: Option[Int]
6.  abstract val optPartitionBinSize: Option[Int]
7.  abstract val optPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]]
   Attributes
     protected
   Definition Classes
     GenomicDataset
8.  abstract val productFn: (T) ⇒ U
   Attributes
     protected
   Definition Classes
     GenomicDataset
9.  abstract val rdd: RDD[T]

   The RDD of genomic data that we are wrapping.

   The RDD of genomic data that we are wrapping.

   Definition Classes
     GenomicDataset
10.  abstract val references: SequenceDictionary

    The sequence dictionary describing the reference assembly this dataset is aligned to.

    The sequence dictionary describing the reference assembly this dataset is aligned to.

    Definition Classes
      GenomicDataset
11.  abstract def replaceRdd(newRdd: RDD[T], newPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]] = None): V
    Attributes
      protected
    Definition Classes
      GenomicDataset
12.  abstract def replaceReferences(newReferences: SequenceDictionary): V

    Replaces the reference sequence dictionary attached to a GenomicDataset.

    Replaces the reference sequence dictionary attached to a GenomicDataset.

    newReferences

      The new reference sequence dictionary to attach.

    returns

      Returns a new GenomicDataset with the reference sequences replaced.

    Definition Classes
      GenomicDataset
13.  abstract def saveAsParquet(pathName: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressionCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false): Unit

    Saves a genomic dataset to Parquet.

    Saves a genomic dataset to Parquet.

    pathName

      The path to save the file to.

    blockSize

      The size in bytes of blocks to write.

    pageSize

      The size in bytes of pages to write.

    compressionCodec

      The compression codec to apply to pages.

    disableDictionaryEncoding

      If false, dictionary encoding is used. If true, delta encoding is used.

    Definition Classes
      GenomicDataset
14.  abstract def transformDataset(tFn: Function[Dataset[U], Dataset[U]]): V

    (Java-specific) Applies a function that transforms the underlying Dataset into a new Dataset using the Spark SQL API.

    (Java-specific) Applies a function that transforms the underlying Dataset into a new Dataset using the Spark SQL API.

    tFn

      A function that transforms the underlying Dataset as a Dataset.

    returns

      A new genomic dataset where the Dataset of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

    Definition Classes
      GenomicDataset
15.  abstract def transformDataset(tFn: (Dataset[U]) ⇒ Dataset[U]): V

    (Scala-specific) Applies a function that transforms the underlying Dataset into a new Dataset using the Spark SQL API.

    (Scala-specific) Applies a function that transforms the underlying Dataset into a new Dataset using the Spark SQL API.

    tFn

      A function that transforms the underlying Dataset as a Dataset.

    returns

      A new genomic dataset where the Dataset of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

    Definition Classes
      GenomicDataset
16.  abstract val uTag: scala.reflect.api.JavaUniverse.TypeTag[U]
    Definition Classes
      GenomicDataset
17.  abstract def union(datasets: V*): V

    (Scala-specific) Unions together multiple genomic datasets.

    (Scala-specific) Unions together multiple genomic datasets.

    datasets

      Genomic datasets to union with this genomic dataset.

    Definition Classes
      GenomicDataset
18.  abstract val unproductFn: (U) ⇒ T
    Attributes
      protected
    Definition Classes
      GenomicDataset

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  def addReference(referenceToAdd: SequenceRecord): V

   Appends metadata for a single reference sequence to the current genomic dataset.

   Appends metadata for a single reference sequence to the current genomic dataset.

   referenceToAdd

     The reference sequence to add.

   returns

     Returns a new GenomicDataset with this reference sequence appended.

   Definition Classes
     GenomicDataset
5.  def addReferences(referencesToAdd: SequenceDictionary): V

   Appends reference sequence metadata to the current genomic dataset.

   Appends reference sequence metadata to the current genomic dataset.

   referencesToAdd

     The new reference sequences to append.

   returns

     Returns a new GenomicDataset with the reference sequences appended.

   Definition Classes
     GenomicDataset
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def broadcast()(implicit tTag: ClassTag[T]): GenomicBroadcast[T, U, V]
   Definition Classes
     GenomicDataset
8.  def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], txTag: ClassTag[(T, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(U, Y)]): GenericGenomicDataset[(T, X), (U, Y)]

   Performs a broadcast inner join between this genomic dataset and another genomic dataset.

   Performs a broadcast inner join between this genomic dataset and another genomic dataset.

   In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

   genomicDataset

     The right genomic dataset in the join.

   returns

     Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

   Definition Classes
     GenomicDataset
   See also

     broadcastRegionJoinAgainst

9.  def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[T], xTag: ClassTag[X], txTag: ClassTag[(T, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(U, Y)]): GenericGenomicDataset[(T, X), (U, Y)]

   Performs a broadcast inner join between this genomic dataset and another genomic dataset.

   Performs a broadcast inner join between this genomic dataset and another genomic dataset.

   In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

   genomicDataset

     The right genomic dataset in the join.

   flankSize

     Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

   returns

     Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

   Definition Classes
     GenomicDataset
   See also

     broadcastRegionJoinAgainst

10.  def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(T, X), (U, Y)]

    (Java-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
11.  def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(T, X), (U, Y)]

    (R-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
12.  def broadcastRegionJoinAgainst[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Y, U)]): GenericGenomicDataset[(X, T), (Y, U)]

    Performs a broadcast inner join between this genomic dataset and data that has been broadcast.

    Performs a broadcast inner join between this genomic dataset and data that has been broadcast.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcast

      The data on the left side of the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling genomic dataset as the right side of the join, and not the left.

    See also

      broadcastRegionJoin

13.  def broadcastRegionJoinAgainstAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], syuTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Y], U)]): GenericGenomicDataset[(Iterable[X], T), (Seq[Y], U)]

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcast

      The data on the left side of the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling genomic dataset as the right side of the join, and not the left.

    See also

      broadcastRegionJoinAndGroupByRight

14.  def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[T], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[U], Y)]): GenericGenomicDataset[(Iterable[T], X), (Seq[U], Y)]

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

15.  def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[T], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[T], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[U], Y)]): GenericGenomicDataset[(Iterable[T], X), (Seq[U], Y)]

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

16.  def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Iterable[T], X), (Seq[U], Y)]

    (Java-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

17.  def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Iterable[T], X), (Seq[U], Y)]

    (R-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

18.  def cache(): V

    Caches underlying RDD in memory.

    Caches underlying RDD in memory.

    returns

      Cached GenomicDataset.

    Definition Classes
      DatasetBoundGenomicDataset → GenomicDataset
19.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... ) @native() @HotSpotIntrinsicCandidate()
20.  def debug(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit
    Attributes
      protected
    Definition Classes
      Logging
21.  def debug(msg: ⇒ Any, t: ⇒ Throwable): Unit
    Attributes
      protected
    Definition Classes
      Logging
22.  def debug(msg: ⇒ Any): Unit
    Attributes
      protected
    Definition Classes
      Logging
23.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
24.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
25.  def error(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit
    Attributes
      protected
    Definition Classes
      Logging
26.  def error(msg: ⇒ Any, t: ⇒ Throwable): Unit
    Attributes
      protected
    Definition Classes
      Logging
27.  def error(msg: ⇒ Any): Unit
    Attributes
      protected
    Definition Classes
      Logging
28.  def filterByOverlappingRegion(query: ReferenceRegion): V

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    query

      The region to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the query region.

    Definition Classes
      GenomicDataset
29.  def filterByOverlappingRegions(querys: Iterable[ReferenceRegion]): V

    (Scala-specific) Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    (Scala-specific) Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    querys

      The regions to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the querys region.

    Definition Classes
      DatasetBoundGenomicDataset → GenomicDataset
30.  def filterByOverlappingRegions(querys: Iterable[ReferenceRegion]): V

    (Java-specific) Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    (Java-specific) Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    querys

      The regions to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the querys region.

    Definition Classes
      GenomicDataset
31.  def flattenRddByRegions(): RDD[(ReferenceRegion, T)]
    Attributes
      protected
    Definition Classes
      GenomicDataset
32.  def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], otoxTag: ClassTag[(Option[T], Option[X])], ouoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[U], Option[Y])]): GenericGenomicDataset[(Option[T], Option[X]), (Option[U], Option[Y])]

    Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either genomic dataset does not overlap any values in the other genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset
33.  def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[T], xTag: ClassTag[X], otoxTag: ClassTag[(Option[T], Option[X])], ouoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[U], Option[Y])]): GenericGenomicDataset[(Option[T], Option[X]), (Option[U], Option[Y])]

    Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either genomic dataset does not overlap any values in the other genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset
34.  def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[T], Option[X]), (Option[U], Option[Y])]

    (Python-specific) Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    (Python-specific) Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either genomic dataset does not overlap any values in the other genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset
35.  def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[T], Option[X]), (Option[U], Option[Y])]

    (R-specific) Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either genomic dataset does not overlap any values in the other genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset
36.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
    Annotations
      @native() @HotSpotIntrinsicCandidate()
37.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native() @HotSpotIntrinsicCandidate()
38.  def info(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit
    Attributes
      protected
    Definition Classes
      Logging
39.  def info(msg: ⇒ Any, t: ⇒ Throwable): Unit
    Attributes
      protected
    Definition Classes
      Logging
40.  def info(msg: ⇒ Any): Unit
    Attributes
      protected
    Definition Classes
      Logging
41.  def isDebugEnabled: Boolean
    Attributes
      protected
    Definition Classes
      Logging
42.  def isErrorEnabled: Boolean
    Attributes
      protected
    Definition Classes
      Logging
43.  def isInfoEnabled: Boolean
    Attributes
      protected
    Definition Classes
      Logging
44.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
45.  def isSorted: Boolean
    Definition Classes
      GenomicDataset
46.  def isTraceEnabled: Boolean
    Attributes
      protected
    Definition Classes
      Logging
47.  def isWarnEnabled: Boolean
    Attributes
      protected
    Definition Classes
      Logging
48.  lazy val jrdd: JavaRDD[T]

    The underlying RDD of genomic data, as a JavaRDD.

    The underlying RDD of genomic data, as a JavaRDD.

    Definition Classes
      GenomicDataset
49.  def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], toxTag: ClassTag[(T, Option[X])], uoyTag: scala.reflect.api.JavaUniverse.TypeTag[(U, Option[Y])]): GenericGenomicDataset[(T, Option[X]), (U, Option[Y])]

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset
50.  def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[T], xTag: ClassTag[X], toxTag: ClassTag[(T, Option[X])], uoyTag: scala.reflect.api.JavaUniverse.TypeTag[(U, Option[Y])]): GenericGenomicDataset[(T, Option[X]), (U, Option[Y])]

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset
51.  def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(T, Option[X]), (U, Option[Y])]

    (Java-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset
52.  def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(T, Option[X]), (U, Option[Y])]

    (R-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset
53.  def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], toxTag: ClassTag[(T, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(U, Seq[Y])]): GenericGenomicDataset[(T, Iterable[X]), (U, Seq[Y])]

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with an empty Iterable in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset
54.  def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[T], xTag: ClassTag[X], toxTag: ClassTag[(T, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(U, Seq[Y])]): GenericGenomicDataset[(T, Iterable[X]), (U, Seq[Y])]

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with an empty Iterable in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset
55.  def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(T, Iterable[X]), (U, Seq[Y])]

    (Java-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    (Java-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with an empty Iterable in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset
56.  def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(T, Iterable[X]), (U, Seq[Y])]

    (R-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    (R-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with an empty Iterable in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset
57.  def logger: Logger
    Attributes
      protected
    Definition Classes
      Logging
58.  def loggerName: String
    Attributes
      protected
    Definition Classes
      Logging
59.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
60.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native() @HotSpotIntrinsicCandidate()
61.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native() @HotSpotIntrinsicCandidate()
62.  def persist(sl: StorageLevel): V

    Persists underlying RDD in memory or disk.

    Persists underlying RDD in memory or disk.

    sl

      new StorageLevel

    returns

      Persisted GenomicDataset.

    Definition Classes
      DatasetBoundGenomicDataset → GenomicDataset
63.  def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[T, U, V, W]](cmd: List[String], files: List[String], environment: Map[String, String], flankSize: Integer, tFormatter: Class[W], xFormatter: OutFormatter[X], convFn: Function2[V, RDD[X], Z]): Z

    (Java/Python-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    (Java/Python-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final genomic dataset.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset
64.  def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[T, U, V, W]](cmd: Seq[Any], files: Seq[Any], environment: Map[Any, Any], flankSize: Double, tFormatter: Class[W], xFormatter: OutFormatter[X], convFn: Function2[V, RDD[X], Z]): Z

    (R-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    (R-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final genomic dataset.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset
65.  def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[T, U, V, W]](cmd: Seq[String], files: Seq[String] = Seq.empty, environment: Map[String, String] = Map.empty, flankSize: Int = 0, optTimeout: Option[Int] = None)(implicit tFormatterCompanion: InFormatterCompanion[T, U, V, W], xFormatter: OutFormatter[X], convFn: (V, RDD[X]) ⇒ Z, tManifest: ClassTag[T], xManifest: ClassTag[X]): Z

    (Scala-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    (Scala-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    Files are substituted in to the command with a $x syntax. E.g., to invoke a command that uses the first file from the files Seq, use $0. To access the path to the directory where the files are copied, use $root.

    Pipes require the presence of an InFormatterCompanion and an OutFormatter as implicit values. The InFormatterCompanion should be a singleton whose apply method builds an InFormatter given a specific type of GenomicDataset. The implicit InFormatterCompanion yields an InFormatter which is used to format the input to the pipe, and the implicit OutFormatter is used to parse the output from the pipe.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    optTimeout

      An optional parameter specifying how long to let a single partition run for, in seconds. If the partition times out, the partial results will be returned, and no exception will be logged. The partition will log that the command timed out.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset
66.  def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], otxTag: ClassTag[(Option[T], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[U], Y)]): GenericGenomicDataset[(Option[T], X), (Option[U], Y)]

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoin

67.  def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[T], xTag: ClassTag[X], otxTag: ClassTag[(Option[T], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[U], Y)]): GenericGenomicDataset[(Option[T], X), (Option[U], Y)]

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoin

68.  def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[T], X), (Option[U], Y)]

    (Java-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
69.  def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[T], X), (Option[U], Y)]

    (R-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
70.  def rightOuterBroadcastRegionJoinAgainst[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], oyuTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Y], U)]): GenericGenomicDataset[(Option[X], T), (Option[Y], U)]

    Performs a broadcast right outer join between this genomic dataset and data that has been broadcast.

    Performs a broadcast right outer join between this genomic dataset and data that has been broadcast.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcast

      The data on the left side of the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling genomic dataset as the right side of the join, and not the left.

    See also

      rightOuterBroadcastRegionJoin

71.  def rightOuterBroadcastRegionJoinAgainstAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], syuTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Y], U)]): GenericGenomicDataset[(Iterable[X], T), (Seq[Y], U)]

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcast

      The data on the left side of the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling genomic dataset as the right side of the join, and not the left.

    See also

      rightOuterBroadcastRegionJoinAndGroupByRight

72.  def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[T], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[U], Y)]): GenericGenomicDataset[(Iterable[T], X), (Seq[U], Y)]

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

73.  def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[T], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[T], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[U], Y)]): GenericGenomicDataset[(Iterable[T], X), (Seq[U], Y)]

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

74.  def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Iterable[T], X), (Seq[U], Y)]

    (Java-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

75.  def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Iterable[T], X), (Seq[U], Y)]

    (R-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

76.  def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], otxTag: ClassTag[(Option[T], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[U], Y)]): GenericGenomicDataset[(Option[T], X), (Option[U], Y)]

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
77.  def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[T], xTag: ClassTag[X], otxTag: ClassTag[(Option[T], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[U], Y)]): GenericGenomicDataset[(Option[T], X), (Option[U], Y)]

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
78.  def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[T], X), (Option[U], Y)]

    (Java-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
79.  def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[T], X), (Option[U], Y)]

    (R-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
80.  def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], otixTag: ClassTag[(Option[T], Iterable[X])], otsyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[U], Seq[Y])]): GenericGenomicDataset[(Option[T], Iterable[X]), (Option[U], Seq[Y])]

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset. Since this is a right outer join, all values from the right genomic dataset who did not overlap a value from the left genomic dataset are placed into a length-1 Iterable with a `None` key.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset, and all values from the right genomic dataset that did not overlap an item in the left genomic dataset.

    Definition Classes
      GenomicDataset
81.  def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[T], xTag: ClassTag[X], otixTag: ClassTag[(Option[T], Iterable[X])], ousyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[U], Seq[Y])]): GenericGenomicDataset[(Option[T], Iterable[X]), (Option[U], Seq[Y])]

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset. Since this is a right outer join, all values from the right genomic dataset who did not overlap a value from the left genomic dataset are placed into a length-1 Iterable with a `None` key.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset, and all values from the right genomic dataset that did not overlap an item in the left genomic dataset.

    Definition Classes
      GenomicDataset
82.  def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[T], Iterable[X]), (Option[U], Seq[Y])]

    (Java-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    (Java-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset. Since this is a right outer join, all values from the right genomic dataset who did not overlap a value from the left genomic dataset are placed into a length-1 Iterable with a `None` key.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset, and all values from the right genomic dataset that did not overlap an item in the left genomic dataset.

    Definition Classes
      GenomicDataset
83.  def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[T], Iterable[X]), (Option[U], Seq[Y])]

    (R-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    (R-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset. Since this is a right outer join, all values from the right genomic dataset who did not overlap a value from the left genomic dataset are placed into a length-1 Iterable with a `None` key.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset, and all values from the right genomic dataset that did not overlap an item in the left genomic dataset.

    Definition Classes
      GenomicDataset
84.  def saveAsParquet(args: SaveArgs): Unit

    Saves a genomic dataset to Parquet.

    Saves a genomic dataset to Parquet.

    args

      The output format configuration to use when saving the data.

    Definition Classes
      GenomicDataset
85.  def saveAsPartitionedParquet(pathName: String, compressionCodec: CompressionCodecName = CompressionCodecName.GZIP, partitionSize: Int = 1000000): Unit

    Saves this RDD to disk in range binned partitioned Parquet format.

    Saves this RDD to disk in range binned partitioned Parquet format.

    pathName

      The path to save the partitioned Parquet file to.

    compressionCodec

      Name of the compression codec to use.

    partitionSize

      Size of partitions used when writing Parquet, in base pairs (bp). Defaults to 1,000,000 bp.

    Definition Classes
      GenomicDataset
86.  def saveAvro[U <: SpecificRecordBase](pathName: String, sc: SparkContext, schema: Schema, avro: Seq[U])(implicit tUag: ClassTag[U]): Unit

    Saves Avro data to a Hadoop file system.

    Saves Avro data to a Hadoop file system.

    This method uses a SparkContext to identify our underlying file system, which we then save to.

    Frustratingly enough, although all records generated by the Avro IDL compiler have a static SCHEMA$ field, this field does not belong to the SpecificRecordBase abstract class, or the SpecificRecord interface. As such, we must force the user to pass in the schema.

    U

      The type of the specific record we are saving.

    pathName

      Path to save records to.

    sc

      SparkContext used for identifying underlying file system.

    schema

      Schema of records we are saving.

    avro

      Seq of records we are saving.

    Attributes
      protected
    Definition Classes
      GenomicDataset
87.  def saveMetadata(pathName: String): Unit

    Writes any necessary metadata to disk.

    Writes any necessary metadata to disk. If not overridden, writes the sequence dictionary to disk as Avro.

    pathName

      The path to save metadata to.

    Attributes
      protected
    Definition Classes
      GenomicDataset
88.  def saveReferences(pathName: String): Unit

    Save the reference sequence dictionary to disk.

    Save the reference sequence dictionary to disk.

    pathName

      The path to save the reference sequence dictionary to.

    Attributes
      protected
    Definition Classes
      GenomicDataset
89.  def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], txTag: ClassTag[(T, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(U, Y)]): GenericGenomicDataset[(T, X), (U, Y)]

    Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

    Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
90.  def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[T], xTag: ClassTag[X], txTag: ClassTag[(T, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(U, Y)]): GenericGenomicDataset[(T, X), (U, Y)]

    Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

    Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
91.  def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(T, X), (U, Y)]

    (Java-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
92.  def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(T, X), (U, Y)]

    (R-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
93.  def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[T], xTag: ClassTag[X], tixTag: ClassTag[(T, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(U, Seq[Y])]): GenericGenomicDataset[(T, Iterable[X]), (U, Seq[Y])]

    Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped. In the same operation, we group all values by the left item in the genomic dataset.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset.

    Definition Classes
      GenomicDataset
94.  def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[T], xTag: ClassTag[X], tixTag: ClassTag[(T, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(U, Seq[Y])]): GenericGenomicDataset[(T, Iterable[X]), (U, Seq[Y])]

    Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped. In the same operation, we group all values by the left item in the genomic dataset.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset.

    Definition Classes
      GenomicDataset
95.  def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(T, Iterable[X]), (U, Seq[Y])]

    (Java-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    (Java-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset.

    Definition Classes
      GenomicDataset
96.  def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(T, Iterable[X]), (U, Seq[Y])]

    (R-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    (R-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset.

    Definition Classes
      GenomicDataset
97.  def sort(partitions: Int = rdd.partitions.length, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[T]): V

    Sorts our genome aligned data by reference positions, with references ordered by index.

    Sorts our genome aligned data by reference positions, with references ordered by index.

    partitions

      The number of partitions for the new genomic dataset.

    stringency

      The level of ValidationStringency to enforce.

    returns

      Returns a new genomic dataset containing sorted data.

    Definition Classes
      GenomicDataset
    Note

      Uses ValidationStringency to handle unaligned or where objects align to multiple positions.

    See also

      sortLexicographically

98.  def sort(): V

    Sorts our genome aligned data by reference positions, with references ordered by index.

    Sorts our genome aligned data by reference positions, with references ordered by index.

    returns

      Returns a new genomic dataset containing sorted data.

    Definition Classes
      GenomicDataset
    See also

      sortLexicographically

99.  def sortLexicographically(partitions: Int = rdd.partitions.length, storePartitionMap: Boolean = false, storageLevel: StorageLevel = StorageLevel.MEMORY_ONLY, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[T]): V

    Sorts our genome aligned data by reference positions, with references ordered lexicographically.

    Sorts our genome aligned data by reference positions, with references ordered lexicographically.

    partitions

      The number of partitions for the new genomic dataset.

    storePartitionMap

      A Boolean flag to determine whether to store the partition bounds from the resulting genomic dataset.

    storageLevel

      The level at which to persist the resulting genomic dataset.

    stringency

      The level of ValidationStringency to enforce.

    returns

      Returns a new genomic dataset containing sorted data.

    Definition Classes
      GenomicDataset
    Note

      Uses ValidationStringency to handle data that is unaligned or where objects align to multiple positions.

    See also

      sort

100.  def sortLexicographically(): V

     Sorts our genome aligned data by reference positions, with references ordered lexicographically.

     Sorts our genome aligned data by reference positions, with references ordered lexicographically.

     returns

       Returns a new genomic dataset containing sorted data.

     Definition Classes
       GenomicDataset
     See also

       sort

101.  lazy val spark: SparkSession
     Definition Classes
       GenomicDataset
     Annotations
       @transient()
102.  final def synchronized[T0](arg0: ⇒ T0): T0
     Definition Classes
       AnyRef
103.  def toDF(): DataFrame

     returns

       These data as a Spark SQL DataFrame.

     Definition Classes
       GenomicDataset
104.  def toString(): String
     Definition Classes
       GenomicDataset → AnyRef → Any
105.  def trace(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit
     Attributes
       protected
     Definition Classes
       Logging
106.  def trace(msg: ⇒ Any, t: ⇒ Throwable): Unit
     Attributes
       protected
     Definition Classes
       Logging
107.  def trace(msg: ⇒ Any): Unit
     Attributes
       protected
     Definition Classes
       Logging
108.  def transform(tFn: Function[JavaRDD[T], JavaRDD[T]]): V

     (Java-specific) Applies a function that transforms the underlying RDD into a new RDD.

     (Java-specific) Applies a function that transforms the underlying RDD into a new RDD.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new genomic dataset where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset
109.  def transform(tFn: (RDD[T]) ⇒ RDD[T]): V

     (Scala-specific) Applies a function that transforms the underlying RDD into a new RDD.

     (Scala-specific) Applies a function that transforms the underlying RDD into a new RDD.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new genomic dataset where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset
110.  def transformDataFrame(tFn: Function[DataFrame, DataFrame]): V

     (Java-specific) Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     (Java-specific) Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     tFn

       A function that transforms the underlying DataFrame as a DataFrame.

     returns

       A new genomic dataset where the DataFrame of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset
111.  def transformDataFrame(tFn: (DataFrame) ⇒ DataFrame)(implicit uTag: scala.reflect.api.JavaUniverse.TypeTag[U]): V

     (Scala-specific) Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     (Scala-specific) Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     tFn

       A function that transforms the underlying data as a DataFrame.

     returns

       A new genomic dataset where the DataFrame of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset
112.  def transmute[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[JavaRDD[T], JavaRDD[X]], convFn: Function2[V, RDD[X], Z]): Z

     (Java-specific) Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     (Java-specific) Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     convFn

       The conversion function used to build the final RDD.

     returns

       A new genomid dataset where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset
113.  def transmute[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (RDD[T]) ⇒ RDD[X])(implicit convFn: (V, RDD[X]) ⇒ Z): Z

     (Scala-specific) Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     (Scala-specific) Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new genomic dataset where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset
114.  def transmuteDataFrame[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[DataFrame, DataFrame], convFn: GenomicDatasetConversion[T, U, V, X, Y, Z]): Z

     (Java-specific) Applies a function that transmutes the underlying DataFrame into a new DataFrame of a different type.

     (Java-specific) Applies a function that transmutes the underlying DataFrame into a new DataFrame of a different type.

     tFn

       A function that transforms the underlying DataFrame.

     returns

       A new genomic dataset where the DataFrame of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset
115.  def transmuteDataFrame[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (DataFrame) ⇒ DataFrame)(implicit yTag: scala.reflect.api.JavaUniverse.TypeTag[Y], convFn: (V, Dataset[Y]) ⇒ Z): Z

     (Java-specific) Applies a function that transmutes the underlying DataFrame into a new DataFrame of a different type.

     (Java-specific) Applies a function that transmutes the underlying DataFrame into a new DataFrame of a different type.

     tFn

       A function that transforms the underlying DataFrame.

     returns

       A new genomic dataset where the DataFrame of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset
116.  def transmuteDataset[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[Dataset[U], Dataset[Y]], convFn: GenomicDatasetConversion[T, U, V, X, Y, Z]): Z

     (Java-specific) Applies a function that transmutes the underlying Dataset into a new Dataset of a different type.

     (Java-specific) Applies a function that transmutes the underlying Dataset into a new Dataset of a different type.

     tFn

       A function that transforms the underlying Dataset.

     returns

       A new genomic dataset where the Dataset of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset
117.  def transmuteDataset[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (Dataset[U]) ⇒ Dataset[Y])(implicit yTag: scala.reflect.api.JavaUniverse.TypeTag[Y], convFn: (V, Dataset[Y]) ⇒ Z): Z

     (Scala-specific) Applies a function that transmutes the underlying Dataset into a new Dataset of a different type.

     (Scala-specific) Applies a function that transmutes the underlying Dataset into a new Dataset of a different type.

     tFn

       A function that transforms the underlying Dataset.

     returns

       A new genomic dataset where the Dataset of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset
118.  def union(datasets: List[V]): V

     (Java-specific) Unions together multiple genomic datasets.

     (Java-specific) Unions together multiple genomic datasets.

     datasets

       Genomic datasets to union with this genomic dataset.

     Definition Classes
       GenomicDataset
119.  def unpersist(): V

     Unpersists underlying RDD from memory or disk.

     Unpersists underlying RDD from memory or disk.

     returns

       Uncached GenomicDataset.

     Definition Classes
       DatasetBoundGenomicDataset → GenomicDataset
120.  final def wait(arg0: Long, arg1: Int): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws( ... )
121.  final def wait(arg0: Long): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws( ... ) @native()
122.  final def wait(): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws( ... )
123.  def warn(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit
     Attributes
       protected
     Definition Classes
       Logging
124.  def warn(msg: ⇒ Any, t: ⇒ Throwable): Unit
     Attributes
       protected
     Definition Classes
       Logging
125.  def warn(msg: ⇒ Any): Unit
     Attributes
       protected
     Definition Classes
       Logging
126.  def writeTextRdd[T](rdd: RDD[T], outputPath: String, asSingleFile: Boolean, disableFastConcat: Boolean, optHeaderPath: Option[String] = None): Unit

     Writes an RDD to disk as text and optionally merges.

     Writes an RDD to disk as text and optionally merges.

     rdd

       RDD to save.

     outputPath

       Output path to save text files to.

     asSingleFile

       If true, combines all partition shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     optHeaderPath

       If provided, the header file to include.

     Attributes
       protected
     Definition Classes
       GenomicDataset

### Deprecated Value Members

1.  def finalize(): Unit
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( classOf[java.lang.Throwable] ) @Deprecated
   Deprecated

### Inherited from GenomicDataset[T, U, V]

### Inherited from Logging

### Inherited from AnyRef

### Inherited from Any

### Ungrouped